********************************************************************
* mkmv: Make a move and update info
*
* Input:  D1  = INFO
*	  R0  = move
*
* Output:
*
* Destroys: A,B,C,D,D0,R1

mkmv	B=0	A

	A=R0
	B=A	B
	GOSUBL	GetBrdI 	; tmp = BRD[fr]
	R1=C			; R1 = Piece

	ST=1	WhiteFlag
	LA(2)   128
	?C<A	B
	GOYES	WhiteMv
	ST=0	WhiteFlag

WhiteMv D=C	A
	C=0	A
	GOSUB	PutBrd		; BRD[fr] = 0
	A=R0
	ASR	A
	ASR	A
	B=A	B
	C=D	A
	GOSUB	PutBrd		; BRD[to] = tmp

	LC(2)   EPSNT
	B=C	B
	C=0	A
	GOSUB	PutInfoB	; EPSNT = 0

	D0=D0-	(EPSNT)-(COL)
	C=DAT0	B
	C=-C	B
	DAT0=C	B		; COL = -COL

* Check if to == a1,e1,h1, a8,e8,h8

	A=R0
	ASR	A
	ASR	A
	LC(2)   #21             ; a1
	?C#A	B
	GOYES	+
	LC(2)   TOA1
	GOSUB	IncInfo
	GOTO	ChkKng

+	LC(2)   #25             ; e1
	?C#A	B
	GOYES	+
	LC(2)   TOA1
	GOSUB	IncInfo
	LC(2)   TOH1
	GOSUB	IncInfo
	GOTO	ChkKng

+	LC(2)   #28             ; h1
	?C#A	B
	GOYES	+
	LC(2)   TOH1
	GOSUB	IncInfo
	GOTO	ChkKng

+	LC(2)   #91             ; a8
	?C#A	B
	GOYES	+
	LC(2)   TOA8
	GOSUB	IncInfo
	GOTO	ChkKng

+	LC(2)   #95             ; e8
	?C#A	B
	GOYES	+
	LC(2)   TOA8
	GOSUB	IncInfo
	LC(2)   TOH8
	GOSUB	IncInfo
	GOTO	ChkKng

+	LC(2)   #98             ; h8
	?C#A	B
	GOYES	ChkKng
	LC(2)   TOH8
	GOSUB	IncInfo

* If king moved, update king positions

ChkKng	A=R1
	LC(2)   6
	?A#C	B
	GOYES	NotVKng
	LC(2)   VKNG
	GOSHORT SetKing
NotVKng LC(2)   256-6
	?A#C	B
	GOYES	NotSKng
	LC(2)   SKNG
SetKing B=C	B
	C=R0
	CSR	A
	CSR	A
	GOSUB	PutInfoB	; XKNG = to

* Check ext1 field

NotSKng A=R0
	ASR	W
	ASR	W
	ASR	W
	ASR	W		; A = [ext2 ext1]
	C=0	A
	?A#C	B
	GOYES	+
	GOTO	AllDone

+	C=C+1	A
	?A#C	B
	GOYES	not1

	LC(2)   SMTL
	?ST=1	WhiteFlag
	GOYES	+
	LC(2)   VMTL
+	B=C	B
	ASR	A
	ASR	A
	GOTO	MtlSub

not1	C=C+1	A
	?A#C	B
	GOYES	not2
	LC(2)   EPSNT
	B=C	B
	ASR	A
	ASR	A
	C=A	A
	GOSUB	PutInfoB	; EPSNT = ext2
	GOTO	AllDone

not2	C=C+1	A
	?A#C	B
	GOYES	not3
	ASR	A
	ASR	A
	B=A	B
	C=0	A
	GOSUB	PutBrd		; BRD[ext2] = 0

	LC(2)   SMTL
	?ST=1	WhiteFlag
	GOYES	+
	LC(2)   VMTL
+	B=C	B
	A=0	A
	A=A+1	A
	GOTO	MtlSub

not3	C=C+1	A
	?A#C	B
	GOYES	not4

	A=R0
	B=A	B
	B=B+CON B,3
	GOSUB	GetBrdI 	; tmp = BRD[fr+3]
	D=C	A
	C=0	A
	GOSUB	PutBrd		; BRD[fr+3] = 0
	B=B-CON B,2
	C=D	A
	GOSUB	PutBrd		; BRD[fr+1] = tmp
	GOTO	AllDone

not4	C=C+1	A
	?A#C	B
	GOYES	not5

	A=R0
	B=A	B
	B=B-CON B,4
	GOSUB	GetBrdI 	; tmp = BRD[fr-4]
	D=C	A
	C=0	A
	GOSUB	PutBrd		; BRD[fr-4] = 0
	B=B+CON B,3
	C=D	A
	GOSUB	PutBrd		; BRD[fr-1] = tmp
	GOTO	AllDone

not5	C=R0
	CSR	A
	CSR	A
	B=C	B		; B = to
	A=A-CON B,16		; promotion piece = ext1-16
	C=A	A
	D=C	A		; D = [ext2 ext1-16]
	GOSUB	PutBrd		; BRD[to] = ext1-16

	A=C	A
	GOSUB	Gtml
	B=C	A		; B = value(ext1-16)
	A=0	A
	A=A+1	A
	GOSUB	Gtml
	B=B-C	A		; B = value(ext1-16)-value(pawn)
	LC(5)   VMTL
	?ST=1	WhiteFlag
	GOYES	+
	LC(2)   SMTL

+	A=DAT1	A
	A=A+C	A
	D0=A
	C=DAT0	A
	C=C+B	A
	DAT0=C	A		; MTL += value

	LC(5)   SMTL
	?ST=1	WhiteFlag
	GOYES	+
	LC(2)   VMTL
+	B=C	A
	C=D	A
	A=C	A
	ASR	A
	ASR	A
MtlSub	GOSUB	Gtml

	A=DAT1	A
	A=A+B	A
	D0=A
	A=DAT0	A
	A=A-C	A
	DAT0=A	A		; XMTL -= (captured piece)

AllDone RTN


********************************************************************
* Gtml: Compute piece value
*
* Input:  A.B = piece
*
* Output: C.A = value
*
* Destroys: A.B,D0

Gtml	LC(2)   128
	?A<C	B
	GOYES	+		; GOYES   IsWhite
	A=-A	B
+	LC(2)   6
	?A<C	B
	GOYES	+
	LC(5)   2*INFTY
	RTN
+	GOSUB	++
	CON(3)  0               ; empty
	CON(3)  100             ; pawn
	CON(3)  325             ; knight
	CON(3)  330             ; bishop
	CON(3)  520             ; rook
	CON(3)  980             ; queen
++	C=RSTK
	D0=C
-	D0=D0+	3
	A=A-1	B
	GONC	-
	D0=D0-	3

	C=0	A
	C=DAT0	3
	RTN

********************************************************************
* GetBrdI: Read a value from BRD
*
* Input:  D1  = INFO
*	  B.A = pos
*
* Output: C.B = BRD[pos]
*	  D0  = target address

GetBrdI D1=D1+	5
	D0=A
	A=DAT1	A
	A=A+B	A
	A=A+B	A
	AD0EX
	D0=D0+	10
	C=DAT0	B
	D1=D1-	5
	RTN

********************************************************************
* PutBrd: Write a value to BRD
*
* Input:  D1  = INFO
*	  B.A = pos
*	  C.B = data
*
* Destroys: A,D0

PutBrd	D1=D1+	5
	A=DAT1	A
	A=A+B	A
	A=A+B	A
	D0=A
	D0=D0+	10
	DAT0=C	B
	D1=D1-	5
	RTN

********************************************************************
* PutInfoB: Write a BYTE to INFO
*
* Input:  D1  = INFO
*	  B.A = offset (i nibbles)
*	  C.b = data
*
* Output: D0  = target address
*
* Destroys: A

PutInfoB
	A=DAT1	A
	A=A+B	A
	D0=A
	DAT0=C	B
	RTN

********************************************************************
* IncInfo: info[pos]++
*
* Input:  D1  = INFO
*	  C.A = offset
*
* Destroys: A,C,D0

IncInfo A=DAT1	A
	A=A+C	A
	D0=A
	C=DAT0	B
	C=C+1	B
	DAT0=C	B
	RTN
