LABEL plmv

( :: CK4&Dispatch # 3333 )           ( MOVES BRD INFO asciimove -> MOVES BRD INFO )

::
  CODE
* Stack: (INFO asciimove -> INFO' [fr to 0 0])
	GOSBVL	save_regs
	D1=D1+	5
	A=DAT1	A
	LC(5)   G_EPSNT
	A=A+C	A
	D0=A
	C=DAT0	B
	B=C	A		; B.B = G_EPSNT
	LC(5)   (EPSNT)-(G_EPSNT)
	A=A+C	A
	D0=A
	C=B	A
	DAT0=C	B		; EPSNT = B.B
	D1=D1-	5

	A=DAT1	A
	D0=A
	D0=D0+	10		; D0 = &asciimove[0]

	GOSUB	convsq
	A=DAT1	A
	D0=A
	D0=D0+	10
	DAT0=C	B

	D0=D0+	4
	GOSUB	convsq
	A=DAT1	A
	D0=A
	D0=D0+	12
	DAT0=C	B

	D0=D0+	2
	C=0	W
	DAT0=C	4

	GOVLNG	rest_loop

********************************************************************
* convsq: Convert a square from ASCII to internal representation
*
* Input:  D0 = &asciimove[0]
*
* Output: C.B = square (or 0 if invalid input data)
*
* Destroys: A,D,D0

convsq	D=0	A
	C=DAT0	B
	LA(2)   'a'
	C=C-A	B
	GOC	error		; if (asciimove[0] < 'a') goto error
	LA(2)   8
	?C>=A	B
	GOYES	error		; if (asciimove[0] >= 'a'+8) goto error
	D=C	B
	D=D+1	A		; D = fr.x

	D0=D0+	2
	C=DAT0	B
	LA(2)   '1'
	C=C-A	B
	GOC	error		; if (asciimove[1] < '1') goto error
	LA(2)   8
	?C>=A	B
	GOYES	error		; if (asciimove[1] >= '1'+8) goto error

	C=C+1	A
	C=C+1	A
	CSL	B
	C=D	P
	RTN

error	C=0	B
	RTN
  ENDCODE

  THREE 1_#1-SUB$ UNROT
  CODE
    CALL  genmoves
  ENDCODE
  4ROLL ZERO
  BEGIN
    #1+ UNROT 2DUP5ROLL POS$ DUP #1- EIGHT #/ DROP #0= OVER#0= OR
  UNTIL
  DUP#0=case
  ::
    3DROP ERRBEEP "Bad Move"
    CODE
      CALL  printmsg
    ENDCODE
    VERYSLOW VERYSLOW
  ;

  SWAPDROP DUP #3+ SUB$ 

  CODE
	GOSBVL	SAVPTR
	A=DAT1	A
	D0=A
	D0=D0+	10
	C=DAT0	8
	R0=C			; R0 = move
	D1=D1+	5		; D1 -> INFO
	GOSUBL	mkmv	
	GOSBVL	GETPTRLOOP
  ENDCODE

  1LAMBIND  ( 1: move )

  CODE
* Stack: (BRD INFO -> BRD INFO')
	GOSBVL	save_regs
	A=DAT1	A
	LC(5)   PLY
	A=A+C	A
	D0=A
	LC(2)   1
	DAT0=C	B		; PLY = 1
	D0=D0+	(Depth)-(PLY)
	DAT0=C	B		; Depth = 1
	D0=D0+	(EXTDEPTH)-(Depth)
	DAT0=C	B		; EXTDEPTH = 1

	D0=D0+	(GOAL)-(EXTDEPTH)
	LC(5)   (INFTY)/2
	DAT0=C	A		; GOAL = INFTY/2
	D0=D0-	(GOAL)-(HI)
	C=-C	A
	DAT0=C	A		; HI = -INFTY/2

	D0=D0+	(GLSCORE)-(HI)
	C=0	A
	DAT0=C	A		; GLSCORE = 0

	GOVLNG	rest_loop
  ENDCODE

  CODE
    CALL  search
  ENDCODE

  1GETLAM

  CODE
	GOSBVL	SAVPTR
	C=DAT1	A
	D0=C
	D0=D0+	10
	C=DAT0	8
	R0=C			; R0 = move
	D1=D1+	5		; D1 -> INFO
	GOSUBL	unmkmv

	GOVLNG	GETPTRLOOP
  ENDCODE

  DROPZERO

  CODE
* Stack: (BRD INFO ZERO -> BRD INFO status)   (0=Invalid move, 1=valid move)
	GOSBVL	save_regs
	D1=D1+	5		; D1 -> INFO
	A=DAT1	A
	LC(5)   HI
	A=A+C	A
	D0=A
	A=DAT0	A		; A = HI
	LC(5)   INFTY
	A=A-C	A		; A = HI - INFTY
	LC(5)   #80000
	?A<C	A
	GOYES	illegal
	D1=D1-	5
	LC(5)   =ONE
	DAT1=C	A		; status = ONE
illegal GOVLNG	rest_loop
  ENDCODE

  #0=case
  ::
    ABND ERRBEEP "Bad Move"
    CODE
      CALL  printmsg
    ENDCODE
    VERYSLOW VERYSLOW
  ;

  1GETABND ZERO CODE
* Stack: (move ZERO -> move status)     (0=normal, 1=pawn promotion)
	GOSBVL	save_regs
	D1=D1+	5		; D1 -> move
	A=DAT1	A
	D0=A
	D0=D0+	10+4
	A=DAT0	B		; A = ext1
	A=A-CON B,6
	GOC	noprom
	D1=D1-	5
	LC(5)   =ONE
	DAT1=C	A		; status = ONE
noprom	GOVLNG	rest_loop
  ENDCODE
  #0=?SKIP
  ::
    TOTEMPOB UNROT "Q,R,B,N ?"
    CODE
      CALL  printmsg
    ENDCODE
    ZERO
    BEGIN
      DROP
      CODE
	CALL  getstring
      ENDCODE
      ::
	DUP "q___" EQUALcase :: DROP FIVE ;
	DUP "r___" EQUALcase :: DROP FOUR ;
	DUP "b___" EQUALcase :: DROP THREE ;
	DUP "n___" EQUALcase :: DROP TWO ;
	DROP ZERO
      ;
    DUP#0<> UNTIL
    4ROLLSWAP CODE
* Stack: (BRD INFO move piece -> BRD INFO move')
	GOSBVL	save_regs
	A=DAT1	A
	D0=A
	D0=D0+	5
	C=DAT0	A
	D=C	A		; D = piece

	D1=D1+	10
	A=DAT1	A
	LC(5)   COL
	A=A+C	A
	D0=A
	C=DAT0	B
	C=C-1	A
	?C=0	B
	GOYES	White		; if (COL == 1) goto White
	D=-D	A
White	LC(2)   16
	D=D+C	A		; D.B = 16piece

	D1=D1-	5
	A=DAT1	A
	D0=A
	D0=D0+	10+4
	C=D	A
	DAT0=C	B		; ext1 = D.B

	GOSBVL	rest_regs
	D1=D1+	5		; DROP
	D=D+1	A
	LOOP
    ENDCODE
  ;

  CODE
    CALL  doscrmove
  ENDCODE
  3GETLAM IT :: TRUE 2PUTLAM ;
  NULL$ 7PUTLAM
;
