ASSEMBLE
	IFDEF	HP49
	NIBASC	/HPHP49-W/
	ELSE
	NIBASC	/HPHP48-E/
	ENDIF

  INCLUDE chess.i

CALL	MACRO
	IFDEF	xx$1
	GOLONG	xx$1
	ELSE
xx$1	A=PC
	LC(5)   ($1)-(*)
	A=A+C	A
	PC=(A)
	ENDIF
	ENDM

RPL
::
  CK0 RECLAIMDISP ClrDA1IsStat
  "    MLChess V1.14\n\n      2001-07-07\n\n  by Peter sterlund"
  TWO FIVE Disp5x7 VERYSLOW VERYSLOW

  RECLAIMDISP TURNMENUOFF NULL$
  INCLUDE stbrd.s
  TOTEMPOB
  INCLUDE info.s
  TOTEMPOB

  FIVE EIGHT
  GROB 5A 8000082000366081C000366000C00036E381E3C3B66681C066F76681C0E7776681C06036660383C30000000000
  XYGROBDISP
  FIVE THIRTYTWO
  GROB 5A 8000082000E38100006066810000606681C3C366E3810660636681C760E16681666063E303C7C3660000000000
  XYGROBDISP

  INCLUDE exstack.s
  FALSE NULL$ "____" 4ROLL
  FALSETRUE FalseFalse ' NULLLAM EIGHT NDUPN DOBIND
			( 8: tmp
			  7: redo-list
			  6: prevcmd
			  5: startdepth
			  4: auto
			  3: opponent
			  2: COMPUTER
			  1: QuitFlag )
  BEGIN
    INCLUDE prmovenum.s
    INCLUDE drawboard.s
    INCLUDE exampos.s
    INCLUDE checkend.s
    DUP#0=ITE DROPNULL$
    ::
      { "Check!" "Draw..." "Mate!" } OVER NTHCOMPDROP
      SWAP #1= ?SEMI FalseFalse 2PUTLAM 4PUTLAM
    ;
    INCLUDE printmsg.s

    2GETLAM ITE
    :: "Thinking"
      CODE
	CALL  printmsg
      ENDCODE
      CODE
* Input: BRD INFO	    Set G_(EXT)DEPTH = (EXT)DEPTH
	GOSBVL	save_regs
	A=DAT1	A
	LC(5)   G_DEPTH
	A=A+C	A
	D0=A
	C=DAT0	4		; Requires (G_EXTDEPTH) - (G_DEPTH) = 2
	B=C	A
	LC(5)   (Depth)-(G_DEPTH)
	A=A+C	A
	D0=A
	C=B	A
	DAT0=C	4		; Requires (EXTDEPTH) - (DEPTH) = 2
	GOVLNG	rest_loop
      ENDCODE
      INCLUDE findbest.s
      INCLUDE doscrmove.s
      FALSE 2PUTLAM
      NULL$ 7PUTLAM
    ;
    ::
      ATTN? IT :: ATTNFLGCLR FALSE 4PUTLAM ;

      4GETLAM ITE
	"go__"
	::
	  INCLUDE getstring.s
	  DUP "____" EQUAL ITE :: DROP 6GETLAM ; :: DUP 6PUTLAM ;
	;

      ::
	DUP "swap" EQUALcase
	::
	  CODE
* Stack: (BRD INFO junk -> BRD INFO' flip?)
	GOSBVL	save_regs
	D1=D1+	5
	A=DAT1	A
	LC(5)   FLAGS
	A=A+C	A
	D0=A
	A=DAT0	B
	?ABIT=0 BOARDFLIP
	GOYES	+
	ABIT=0	BOARDFLIP
	LC(5)   =ONE
	GOTO	++
+	ABIT=1	BOARDFLIP
	LC(5)   =TWO
++	DAT0=A	B		; BOARDFLIP = ~BOARDFLIP
	D1=D1-	5
	DAT1=C	A
	GOVLNG	rest_loop
	  ENDCODE
	  INCLUDE nbeep.s
	;
	DUP "quit" EQUALcase :: DROP 3DROP TRUE 1PUTLAM ;
	DUP "save" EQUALcase
	:: DROP 3PICK TOTEMPOB 3PICK TOTEMPOB 3PICK TOTEMPOB THREE{}N 4UNROLL ;
	DUP "load" EQUALcase
	:: DROP DEPTH 5GETLAM #=case
	  ::
	    ERRBEEP "Not saved"
	    CODE
	      CALL  printmsg
	    ENDCODE
	    VERYSLOW VERYSLOW
	  ;
	  3DROP TOTEMPOB INCOMPDROP
	  NULL$ 7PUTLAM
	;
	DUP "go__" EQUALcase :: DROP TRUE 2PUTLAM ;
	DUP "auto" EQUALcase :: DROP TRUE 4PUTLAM ;
	DUP "undo" EQUALcase
	::
	  DROP
	  INCLUDE undoscrmove.s
	;
	DUP "strt" EQUALcase
	::
	  DROP
	  FIFTYSIX DUP TestSysFlag 8PUTLAM SetSysFlag
	  BEGIN
	    CODE
	      CALL  undoscrmove
	    ENDCODE
	    3PICK NULL$?
	  UNTIL
	  8GETLAM ?SKIP :: FIFTYSIX ClrSysFlag ;
	;
	DUP "redo" EQUALcase
	::
	  DROP
	  7GETLAM NULL$? ITE
	  ::
	    ERRBEEP "No Moves"
	    CODE
	      CALL  printmsg
	    ENDCODE
	    VERYSLOW VERYSLOW
	  ;
	  ::
	    7GETLAM DUP FIVE OVERLEN$ SUB$ 7PUTLAM
	    FIVE 1_#1-SUB$
	    CODE
	      CALL  doscrmove
	    ENDCODE
	  ;

	;
	DUP "new_" EQUALcase
	::
	  DROP 3DROP NULL$
	  CODE
	    CALL  stbrd
	  ENDCODE
	  TOTEMPOB
	  CODE
	    CALL info
	  ENDCODE
	  TOTEMPOB
	  NULL$ 7PUTLAM
	;
	DUP "beep" EQUALcase
	:: DROP FIFTYSIX DUP TestSysFlag ITE
	  ::
	    ClrSysFlag TWO
	    CODE
	      CALL  nbeep
	    ENDCODE
	  ;
	  ::
	    ONE
	    CODE
	      CALL  nbeep
	    ENDCODE
	    SetSysFlag
	  ;
	;
	DUP "oppo" EQUALcase
	:: DROP 3GETLAM NOT DUP 3PUTLAM FALSE 2PUTLAM
	  ITE TWO ONE
	  CODE
	    CALL  nbeep
	  ENDCODE
	;
	DUP "edit" EQUALcase
	::
	  DROP
	  INCLUDE edit.s
	  NULL$ 7PUTLAM
	;
	DUP "lev1" EQUALcase
	::
	  DROP ONE
	  INCLUDE setlev.s
	;
	DUP "lev2" EQUALcase
	::
	  DROP TWO
	  CODE
	    CALL  setlev
	  ENDCODE
	;
	DUP "lev3" EQUALcase
	::
	  DROP THREE
	  CODE
	    CALL  setlev
	  ENDCODE
	;
	DUP "lev4" EQUALcase
	::
	  DROP FOUR
	  CODE
	    CALL  setlev
	  ENDCODE
	;
	DUP "lev_" EQUALcase
	::
	  DROP 0 TOTEMPOB
	  CODE
* Stack: (BRD INFO 0 -> BRD INFO' lev)
	GOSBVL	save_regs
	D1=D1+	5
	A=DAT1	A
	LC(5)   G_DEPTH
	A=A+C	A
	D0=A
	A=0	A
	A=DAT0	B
	A=A-1	A
	D1=D1-	5
	C=DAT1	A
	D1=C
	D1=D1+	5
	DAT1=A	A
	GOVLNG	rest_loop
	  ENDCODE
	  "Level " SWAP FORTYEIGHT #+ #>CHR >T$
	  CODE
	    CALL  printmsg
	  ENDCODE
	  VERYSLOW VERYSLOW
	;
	DUP "pset" EQUALcase
	::
	  CODE
* Stack: (BRD INFO junk -> BRD INFO')
	D1=D1+	5		; DROP
	GOSBVL	save_regs
	A=DAT1	A
	LC(5)   FLAGS
	A=A+C	A
	D0=A
	A=DAT0	B
	?ABIT=0 OLDPIECES
	GOYES	+
	ABIT=0	OLDPIECES
	GOTO	++
+	ABIT=1	OLDPIECES
++	DAT0=A	B		; OLDPIECES = ~OLDPIECES
	GOVLNG	rest_loop
	  ENDCODE
	;

	INCLUDE plmv.s
      ;
    ;
    1GETLAM
  UNTIL

  ABND ClrDAsOK
;
